/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.webosinternals.services;

import com.palm.luna.LSException;
import com.palm.luna.service.LunaServiceThread;
import com.palm.luna.service.ServiceMessage;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import org.json.JSONException;
import org.json.JSONObject;

/**
 *
 * @author aliscissons
 */
public class HelloService extends LunaServiceThread {

    private String hwVersion = "0.1";

    /**
     * Quite possibly returns a JSON object with a version string!
     *
     * @param msg
     */
    @LunaServiceThread.PublicMethod
    public void version(ServiceMessage msg) throws LSException {
        try {
            StringBuilder sb = new StringBuilder(8192);
            sb.append("{version:");
            sb.append(JSONObject.quote(this.hwVersion));
            sb.append("}");
            msg.respond(sb.toString());
        } catch (LSException e) {
            msg.respondError("ERROR", "Internal failure.");
        }
    }

    @LunaServiceThread.PublicMethod
    public void hello(ServiceMessage msg) throws JSONException, LSException {
        if (msg.getJSONPayload().has("name")) {
            String name = msg.getJSONPayload().getString("name");
            JSONObject reply = new JSONObject();
            reply.put("yourmsg", "Hello, " + name + "!");
            msg.respond(reply.toString());
        } else {
            msg.respondError("ERROR", "Parameter 'name' required.");
        }
    }
}
